/*
 * directory auditing tool
 * .airport man <airportman@poc.csoft.net>
 */

/*
  [03/15/99] Fixed bug for nonexisting users in dorep() -
             removed OPT_PASSWD.
 */

#include "tmp-audit.h"

int opt_dheader=0, opt_clear=0, opt_log=0;
char tmp_dir[255];
char log_file[255];

void
dorep(name)
     char* name;
{
  char f_file[255];
  struct stat dstat;

  sprintf(f_file,"%s/%s",tmp_dir,name);

  printf("%30s ", name);
  if( !access(f_file,F_OK) ) {
    if( stat(f_file,&dstat) <0 )
      perror("stat()");
    else {
      static struct passwd* passwd;
      if( !(passwd=getpwuid(dstat.st_uid)) )
	printf("%10o [(%d)/%d]\n",
	       dstat.st_mode, dstat.st_uid, dstat.st_gid);
      else
	printf("%10o [%s/%d]\n",
	       dstat.st_mode, passwd->pw_name, dstat.st_gid);
    }
  }
}

void
doscan()
{
  struct dirent **den;
  int i=0, i2=0, il;
  short int changenum=0;

  while(1) {
    i=scandir(tmp_dir,&den,0,0);

    if(i != i2) {
      if(opt_clear)
	system(CLEAR_LOC);
      if(opt_dheader)
	printf("\a\n[%s - Change %i]\n",tmp_dir,changenum);

      for(il=0;il<i;il++)
	if( (strcmp(".",den[il]->d_name) != 0) &&
	    (strcmp("..",den[il]->d_name)) ) {
	  dorep(den[il]->d_name);
	}
      i2=i;
      changenum++;
    }

#ifdef SLEEP_PERIOD
    sleep(SLEEP_PERIOD);
#endif
  }
}

void
main(argc,argv)
     int argc;
     char** argv;
{
  int c, o1=0;

  /* parse command-line parameters */
  while( (c=getopt(argc,argv,"d:lch")) != EOF ) {
    switch(c) {
    case 'd':
      strncpy(tmp_dir,optarg,sizeof(tmp_dir));
      o1=1;
      break;
    case 'l':
      opt_dheader=1;
      break;
    case 'c':
      opt_clear=1;
      break;
    case 'h':
      printf(USAGE,argv[0]);
      exit(0);
    case 'v':
      printf("%s\n",VERSION);
      exit(0);
    }
  }
  if(!o1)
    strcpy(tmp_dir,DEFAULT_DIR);

  doscan();
}
